﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Telerik.Everlive.Sdk.Core;
using Telerik.Windows.Cloud;
using Memories.Models;
using Telerik.Windows.Controls;

namespace Memories.Views
{
    public partial class AddOrEditMemory : PhoneApplicationPage
    {
        public AddOrEditMemory()
        {
            InitializeComponent();
        }

        protected async override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            Memory memory;

            if (this.NavigationContext.QueryString.ContainsKey("id"))
            {
                string id = this.NavigationContext.QueryString["id"];
                Guid guid = new Guid(id);
                EverliveApp everliveApp = CloudProvider.Current.NativeConnection as EverliveApp;
                memory = await everliveApp.WorkWith().Data<Memory>().GetById(guid).ExecuteAsync();
            }
            else
            {
                this.PageTitleBlock.Text = "add";
                memory = new Memory();
            }

            this.DataContext = memory;
        }

        private void OnSave_Click(object sender, EventArgs e)
        {
            this.MemoryDataForm.Commit();
        }

        private void OnCancel_Click(object sender, EventArgs e)
        {
            this.NavigationService.GoBack();
        }

        private void MemoryDataForm_Success(object sender, EventArgs e)
        {
            PhoneApplicationService.Current.State["ReloadMemories"] = true;
            this.NavigationService.GoBack();
        }

        private async void MemoryDataForm_Failed(object sender, EventArgs e)
        {
            await RadMessageBox.ShowAsync("Memory can't be saved. Please try again later.");
        }
    }
}