﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Navigation;
using Microsoft.Phone.Controls;
using Microsoft.Phone.Shell;
using Telerik.Windows.Controls.Cloud;
using Memories.Models;
using Telerik.Windows.Cloud;
using System.Linq.Expressions;

namespace Memories.Views
{
    public partial class Memories : PhoneApplicationPage
    {
        EverliveCloudDataService<Memory> memoriesService;

        public Memories()
        {
            InitializeComponent();
            this.InitializeCloudService();
        }

        private void InitializeCloudService()
        {
            Expression<Func<Memory, bool>> expression = memory => memory.CreatedBy == CloudProvider.Current.CurrentUser.GetId();
            this.memoriesService = new EverliveCloudDataService<Memory>();
            this.memoriesService.Filter = expression;
            this.jumpList.CloudDataService = memoriesService;
        }

        private void OnItemTap(object sender, Telerik.Windows.Controls.ListBoxItemTapEventArgs e)
        {
            Guid itemId = (e.Item.Content as Memory).Id;
            this.NavigationService.Navigate(new Uri(string.Format("/Views/ViewMemory.xaml?id={0}", itemId), UriKind.RelativeOrAbsolute));
        }

        private async void OnLogout_Click(object sender, EventArgs e)
        {
            bool logoutSuccess = await RadCloudLogin.LogoutAsync();
            if (logoutSuccess)
            {
                this.NavigationService.GoBack();
            }
        }

        protected override void OnNavigatedTo(NavigationEventArgs e)
        {
            base.OnNavigatedTo(e);

            if (e.NavigationMode == NavigationMode.Back && PhoneApplicationService.Current.State.ContainsKey("ReloadMemories"))
            {
                PhoneApplicationService.Current.State.Remove("ReloadMemories");
                jumpList.ReloadCloudItemsAsync();
            }
        }

        private void OnNewMemoryButton_Click(object sender, EventArgs e)
        {
            this.NavigationService.Navigate(new Uri("/Views/AddOrEditMemory.xaml", UriKind.RelativeOrAbsolute));
        }
    }
}